#include <bits/stdc++.h>

using namespace std;

int f(int n)
{
    int i=4;
    for(;i*(i-1)*(i-2)<=6*n;i++);
    i--;
    return i;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n; cin >> n;cin.tie(0);
    vector <int> v;
    int sum=0;
    while(n>3)
    {
        int i=f(n);
        v.push_back(i);
        n=n-((i)*(i-1)*(i-2))/6;
        sum=sum+i;
    }
    while(n)
    {
        sum=sum+3;
        v.push_back(3);
        n--;
    }
    cout << sum << '\n';
    int j=0;
    for(int i=0;i<sum;i++)
    {
        if(v[j])
            v[j]--;
        else
        {
            j++;
            v[j]--;
        }
        cout << i << " " << i+j << '\n';
    }
    return 0;
}